<%@     page import="java.security.MessageDigest, java.text.SimpleDateFormat, java.util.Date, java.io.UnsupportedEncodingException" %>  
    <%!
    
    private static final String STORE_ID = "12066666666"; 
    private static final String SHARED_SECRET = "ganzGeheim";
    private static final SimpleDateFormat DATE_FORMAT = new SimpleDateFormat("yyyy:MM:dd-HH:mm:ss");

    private String createHash(String chargetotal, String currency, Date dateToUse) throws UnsupportedEncodingException    {

      String formattedDate = DATE_FORMAT.format(dateToUse);

      // NOTE: Please DO NOT hardcode the secret in that script. For example read it from a database.
      String stringToHash = STORE_ID + formattedDate + chargetotal + currency + SHARED_SECRET;
      String hexString = toHex(stringToHash);
      String hash = stringToSha1(hexString);
      return hash;
    }
    
    private String toHex(String value) throws UnsupportedEncodingException   
    {
      byte[] bytes = value.getBytes("ISO-8859-1"); 
      return toHex(bytes);
    }

    private String toHex(byte[] bytes) throws UnsupportedEncodingException   
    {
      StringBuilder str = new StringBuilder();
      for (int i = 0; i < bytes.length; i++){
        str.append(String.format("%02x", bytes[i]));
      }
      return str.toString();
    }

      private String stringToSha1(String stringToEncode) {
        MessageDigest md = null;
        String result = null;
        try {
          byte[] bytes = stringToEncode.getBytes("ISO-8859-1"); 
          md = MessageDigest.getInstance("SHA-1");
          byte[] encyptedString = md.digest(bytes);
          result = toHex(encyptedString);
        }
        catch(Exception e) {
          e.printStackTrace();
        } 
        return result;
      }
    
    %>
